--[[

]]--
local addonName, vars = ...
local L = vars.L --- localizzazione
local ERA = _G[addonName]

local tinsert, abs, format,GetGameTime,CalendarGetDate, date,time,gsub = table.insert, math.abs, string.format,GetGameTime,CalendarGetDate, date,time,gsub
local closeTime = 15

--time + il fuso del server
local function ServerGlobalTime(timeTable,diffDays)	
	local fuso = 0
	if ERA:UseServerTime() and ERA:GetServerFusoOrario() then
		fuso = ERA:GetServerFusoOrario()
	end
	local tempo = time(timeTable) + fuso*3600 + (diffDays or 0)*24*3600
	return tempo
end

--nuova data da ora + Xgiorni
local function NewDate(diffDays)	
	local tempo = ServerGlobalTime(nil,diffDays)
	local t = date("*t",tempo)
	return t.day,t.month,t.year
end

--monthoffset data una differenza di giorni
local function NewOffset(diffDays)
	local giorno, mese, anno = ERA:GetGameTime("g","M","a")
	local newDay, newMonth, newYear = NewDate(diffDays)
	local newOffset = (newYear - anno)*12 + newMonth - mese
	--print ("nuovo Offset =", newOffset, newDay)
	return newOffset, newDay
end

--se due ore differiscono di meno di 15min (o difftime)
local function IsClose(o,m,o1,m1)	
--print("IsClose =",abs((o*60+m) - (o1*60+m1)) <closeTime)
   if abs((o*60+m) - (o1*60+m1)) <closeTime then return true end
end

--se ora differisce di meno di 15min da un'altra data
local function NowIsCloseTo(o,m,g,M,a)
	local t = {}
	--print("dati =",o,m,g,M,a)
	t.year = a or ERA:GetGameTime("a")
	t.month = M or ERA:GetGameTime("M")
	t.day = g or ERA:GetGameTime("g")
	t.hour = o or ERA:GetGameTime("o")
	t.min = m or ERA:GetGameTime("m")	
	local now = ServerGlobalTime()
	local notNow = time(t)
	local diff = abs(now-notNow)
	diff = (diff-(diff%60))/60
	--print("ora =",date("%d/%m/%y %H:%M",now))
	--print("nuova =",date("%d/%m/%y %H:%M",notNow))
	--print("vicinanza a",o,m,g,M,a,"=",diff)
	if  diff <=closeTime then return true end
end

--restituisce una stringa contentente i parametri posizionali localizzati per la data da utilizzare solo per la funzione os.date()
function ERA:FormatoPerDate()
	local data = gsub(SHORTDATE, "%%3$02d", "%%y")
	data = gsub(data, "%%2$d", "%%m")
	data = gsub(data, "%%1$02d", "%%d")
	data = format("%s  %%H:%%M",data)
	ERA:SetTempVal("FormatoPerDate", data)
	return data
end

--inizializza una stringa contentente i parametri posizionali localizzati per scrivere la data con format()
function ERA:DataPerFormat()
	local data = gsub(SHORTDATE, "%%3$02d", "%%3$d")	
	data = format("%s, %%02d:%%02d",data)
	--print(data)
	ERA:SetTempVal("DataPerFormat",data)
	return data
end

--apre il calendario al primo login
function ERA:CALENDAR_UPDATE_EVENT_LIST(...)
   --print(...)
   ERA:CancelTimer(ERA:GetTempVal("openingCalendar"))
   ERA:SetTempVal("openingCalendar")
   ERA:SetTempVal("calendarOpened",true)   
   ERA:UnregisterEvent("CALENDAR_UPDATE_EVENT_LIST")
   LibStub("AceConfigRegistry-3.0"):NotifyChange(addonName)--cambia le opzioni se sono aperte
   ERA:InviteButtonUpdate()--il pulsante del monitor, se e' aperto
end


function ERA:UpdateCalendar()
   local times = ERA:GetTempVal("calendarOpeningTries") or 0
   times = times + 1
   --print(times)
   ERA:RegisterEvent("CALENDAR_UPDATE_EVENT_LIST")
   ERA:SetTempVal("calendarOpened")
   OpenCalendar()       
   ERA:SetTempVal("calendarOpeningTries",times)
   if times >  1 then             --se dopo 10 secondi il server non ha risposto, inutile insistere
      ERA:SetTempVal("calendarOpeningTries")
	  ERA:CALENDAR_UPDATE_EVENT_LIST()
   end
   
end

function ERA:IniCalendar()
   if not ERA:GetTempVal("calendarOpened") then
      local t=  ERA:ScheduleRepeatingTimer("UpdateCalendar",2)
      ERA:SetTempVal("openingCalendar",t)
   end   
end

function ERA:GetServerFusoOrario()
	local db = ERA:DB()   
	return db.calendar.serverFusoOrario
end

function ERA:SetPrimoFuso()	
	local oraS = GetGameTime()
	local oraL = ERA:GetGameTime("o")
	local fuso = oraS - oraL
	local db = ERA:DB()   
	db.calendar.serverFusoOrario = fuso
	return fuso
end

--restituisce giorno ora minuto mese anno di ora in base a cosa si richiede e nello stesso ordine.
function ERA:GetGameTime(v1,v2,v3,v4,v5,v6)   
	local tempo = ServerGlobalTime()
	local t = date("*t",tempo)
	local r = {}
	r["a"],r["M"],r["g"],r["o"],r["m"],r["s"] = t.year, t.month, t.day, t.hour, t.min, t.sec
	if v1 =="*t" then 
		return r 
	else
		return r[v1],r[v2],r[v3],r[v4],r[v5],r[v6]
	end
end

--scrive nel db quando abbiamo importato, da cosa e aggiorna il monitor perche' lo mostri.
function ERA:SetImportData(dataTable)
	 ERA:SetImportDate()
	 ERA:SetMonitorImportDate()
	 ERA:SetImportType(dataTable)    
end

--apre l'evento di indice i al giorno g nel mese corrente
function ERA.OpenEvent(giorno,index,meseDiff)
   ERA:SetTempVal("workingEventTable",{})--se siamo qui non serve più
   meseDiff = meseDiff or 0
   ERA:RegisterEvent("CALENDAR_OPEN_EVENT")
   ERA.openingEvent = true
   CalendarOpenEvent(meseDiff, giorno, index)
end

--cerca se esistono eventi per il giorno indicato
--se close e' true cerca solo eventi prossimi (+/-closeTime min dall'ora corrente).
function ERA:GetDayEvents(close, eventDay, monthOffset)
--print("ERA:GetDayEvents",close, eventDay, monthOffset)
	CalendarSetMonth(0)
	local wet = ERA:GetTempVal("workingEventTable")
	monthOffset, eventDay = monthOffset or 0 , eventDay or ERA:GetGameTime("g")
	local numEvents = CalendarGetNumDayEvents(monthOffset, eventDay)
	if not numEvents then 
		ERA:AddAlert(format("%s %s.",L["Nessun evento"],close and format(L["vicino (+/- %s minuti da ora)"],closeTime) or ""))
		return 
	end
	local title, hour, minute, calendarType,modStatus 
	local o, m = ERA:GetGameTime("o","m")   
	if ERA:GetTempVal("altroTempo") == 1 then o,m = 0,0 end
	if ERA:GetTempVal("altroTempo") == -1 then o,m = 23,59 end
	for i = 1, numEvents do		   
		title, hour, minute, calendarType, _, _, _, modStatus = CalendarGetDayEvent(monthOffset, eventDay, i)	  
		--print(title, hour, minute, calendarType,modStatus,IsClose(o,m,hour,minute) )
		if calendarType == "PLAYER" and (not close or IsClose(o,m,hour,minute)) then
			tinsert(wet, {index = i, titolo = title, meseDiff = monthOffset, giorno = eventDay, ora = hour, min = minute, mod = modStatus})         
		end
	end	
	if close and not ERA:GetTempVal("altroTempo") then 	
	--print("ERA._guardaAltroTempo",ERA:GetTempVal("altroTempo"))
		if NowIsCloseTo(0,0,NewDate(1)) then
			--print("cerco domani")
			ERA:SetTempVal("altroTempo",1)		
			local newMonthOffset, newEventDay  = NewOffset(1)
			ERA:GetDayEvents(close, newEventDay, newMonthOffset)
			return
		end
		if NowIsCloseTo(23,59,NewDate(-1)) then
			--print("cerco ieri")
			ERA:SetTempVal("altroTempo",-1)
			local newMonthOffset, newEventDay  = NewOffset(-1)
			ERA:GetDayEvents(close, newEventDay, newMonthOffset)
			return
		end		
	end		
	ERA:SetTempVal("altroTempo")		
	if not next(wet) then
		ERA:AddAlert(format("%s %s.",L["Nessun evento"],close and format(L["vicino (+/- %s minuti da ora)"],closeTime) or ""))
		return 
	end  	
	if #wet == 1 then
		ERA:SetTempVal("pickedEvent", wet[1])
		ERA.OpenEvent(wet[1].giorno, wet[1].index, wet[1].meseDiff) 		
	else
		ERA:PickEventFrame(wet)      
	end		
end

--apre l'evento scelto e importa i nomi
function ERA:CALENDAR_OPEN_EVENT()
	--print("open")
	if not ERA.openingEvent then return end
	local wt = {}
	local CONFIRMED = 4
	local inv = CalendarEventGetNumInvites()
	local confirmed = 0
	local pgName, level, className, classFileName, inviteStatus, modStatus, inviteIsMine, inviteType
	for i = 1, inv do
		pgName, level, className, classFileName, inviteStatus, modStatus, inviteIsMine, inviteType = CalendarEventGetInvite(i)
		if pgName and inviteStatus == CONFIRMED then
			--print(i, pgName)
			confirmed = confirmed + 1
			wt[pgName] = true
		end
	end
	CalendarCloseEvent()
	ERA.openingEvent = nil
	local i = 0
	if next(wt) then     
		ERA:WipeDrafted()
		for k in pairs(wt) do
			if k and k~="" then 
				ERA:AddToDrafted(k)
				i = i+1
			end
		end      
		ERA:SetImportData(ERA:GetTempVal("pickedEvent"))
		LibStub("AceConfigRegistry-3.0"):NotifyChange(addonName)--cambia le opzioni se sono aperte
	end   	
	if i ~= confirmed then
		if not ERA:GetTempVal("secondoTentativo") then--per motivi misteriosi a volte non funziona, sempre meglio riprovare in caso
			--print("secondoTentativo")
			ERA:SetTempVal("secondoTentativo", not ERA:GetTempVal("secondoTentativo"))
			local t = ERA:GetTempVal("pickedEvent")
			ERA.OpenEvent(t.giorno, t.index, t.meseDiff)
			return
		else
			ERA:AddAlert((format(L["Errore nell'importazione, importati solo %d inviti su %d attesi. Si consiglia di riprovare."],i,confirmed)))			
		end		
	end
	ERA:SetTempVal("secondoTentativo")
	ERA:SetTempVal("pickedEvent")
	ERA:UnregisterEvent("CALENDAR_OPEN_EVENT")	
	return i
end

--singolo pulsante per la scelta dell'evento.
local function EventButton(parent)		
	local b = CreateFrame("Button",nil,parent)
	b:SetSize(1,24)
	b:SetPoint("TOP",UIParent, "TOP", 0, -50)
	
	b.bg = b:CreateTexture(nil, "BACKGROUND",nil,-7)
	b.bg:SetAllPoints()	
	b.bg:SetTexture([[Interface\Calendar\EventHighlight]])
	b.bg:SetTexCoord(0,1,0.5,1)
	b.bg:SetAlpha(0.4)
	
	b.bgh= b:CreateTexture(nil, "BACKGROUND",nil,-6)
	b.bgh:SetAllPoints()
	b.bgh:SetTexture([[Interface\Calendar\EventHighlight]])
	b.bgh:SetTexCoord(0,1,0,0.5)
	b:SetHighlightTexture(b.bgh)
	
	b.line1 = b:CreateFontString(nil,nil,"GameFontNormalSmall")
	b.line1:SetPoint("TOPLEFT")
	b.line1:SetPoint("TOPRIGHT")
	b.line1:SetPoint("BOTTOMRIGHT", 0, b:GetHeight()*0.5)
	--b.line1:SetJustifyH("LEFT")	
	
	b.line2 = b:CreateFontString(nil,nil,"GameFontHighlightSmall")
	b.line2:SetPoint("TOPLEFT",b.line1,"BOTTOMLEFT")
	b.line2:SetPoint("TOPRIGHT",b.line1,"BOTTOMRIGHT")
	b.line2:SetPoint("BOTTOMRIGHT", b,"BOTTOMRIGHT")
	--b.line2:SetJustifyH("LEFT")	
	
	b:SetScript("OnHide", function()            
			b:ClearAllPoints()        
			b:Hide()
		end)
	function b:ERATextFromEvent(eventTable)
		local width
		b:SetScript("OnClick", function() ERA:SetTempVal("pickedEvent",eventTable); ERA.OpenEvent(eventTable.giorno, eventTable.index, eventTable.meseDiff);parent:Hide() end)
		local meseC, annoC = ERA:GetGameTime("M","a")
		local mese,anno
		mese = meseC + eventTable.meseDiff		
		anno = math.ceil((mese-12)/12)
		mese = mese-anno*12
		anno = annoC+anno
		b.line1:SetFormattedText("%s",eventTable.titolo)
		b.line1:SetTextColor(0,1,0)
		if eventTable.mod and eventTable.mod =="CREATOR" then
			b.line1:SetTextColor(0.4,0.8,0.9)
		end
		b.line2:SetFormattedText(ERA:GetTempVal("DataPerFormat"),eventTable.giorno,mese,anno,eventTable.ora,eventTable.min) 		
	end
	function b:ERAWidth()		
		return max(strlen(self.line1:GetText()),strlen(self.line2:GetText()))
	end
	b.CreateFromEvent = CreateFromEvent
	return b
end
--frame per la scelta dell'evento
function ERA:PickEventFrame(eventsTable)
   --{index = i, titolo = title, meseDiff = monthOffset, giorno = eventDay, ora = hour, min = minute, mod = modStatus ~=""  and true or nil}
	local caller = GetMouseFocus()   
	local p = ERA:GetTempVal("PickEventFrame")
	if not p then
		p = ERA:Frame({lockable = false,})	
		p.border = CreateFrame("Frame",nil,p)
		p.border:SetPoint("TOPLEFT",-5,7)
		p.border:SetPoint("BOTTOMRIGHT",5,-5)
		p.border:SetBackdrop({edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border",	edgeSize = 32,})		
		p:SetAlpha(1)
		p.ERA:SetTitle(L["Scegli un evento:"])
		p.bg:SetTexture([[Interface\Calendar\CalendarBackground]])
		p.bg:SetTexCoord(0,0.35,0,0.35)
		p:SetPoint("TOPRIGHT",caller,"TOPLEFT",0,0) 
		ERA:SetTempVal("PickEventFrame",p)		
	end		 
	p:ClearAllPoints()    
	p:SetFrameStrata(caller:GetFrameStrata())
	p:SetFrameLevel(caller:GetFrameLevel()+1)
	p:SetScript("OnMouseDown", function() p:SetFrameLevel(caller:GetFrameLevel()+1) end)   
   
	local anchor
	local width = p:GetWidth()
	local meseC, annoC,mese,anno = ERA:GetGameTime("M","a")
	for i, t in ipairs(eventsTable) do        
		p[i] = p[i] or EventButton(p)
		p[i]:ERATextFromEvent(t)
		width = max(width, p[i]:ERAWidth()*7+20)
		p[i]:SetPoint("TOPLEFT",anchor,"BOTTOMLEFT",0,-1)
		p[i]:SetPoint("TOPRIGHT",anchor,"BOTTOMRIGHT")
		p[i]:Show()
		anchor = p[i]
	end

	p:SetSize(width,24*#eventsTable+20+#eventsTable+6)   
	p:SetPoint("TOPRIGHT",caller,"TOPLEFT",0,0) 
	p[1]:SetPoint("TOPLEFT",p.title,"BOTTOMLEFT",0,-1)
	p[1]:SetPoint("TOPRIGHT",p.title,"BOTTOMRIGHT",0,-1)

	p:Show()
	ERA:SetTempVal("workingEventTable",{})
end
--hook il pulsante invita negli eventi.
function ERA:ADDON_LOADED(event,addon)
   if addon == "Blizzard_Calendar" then
      local btn = _G.CalendarCreateEventRaidInviteButton
      if btn then
         ERA:SetTempVal("calendarInviteBtn", btn)
         btn:HookScript("OnClick", function() ERA:HookInviteButton()end)
         ERA:UnregisterEvent("ADDON_LOADED")
      end
   end
end

--funzione che viene "hookata" nel pulsante invita degli eventi.
function ERA:HookInviteButton()
   local btn = ERA:GetTempVal("calendarInviteBtn")
   if btn and btn:IsVisible() and btn:GetText() == CALENDAR_INVITE_MEMBERS and CalendarEventGetCalendarType() == "PLAYER" then
      local monthOffset, eventDay, i = CalendarGetEventIndex()
      local title, hour, minute, _, _, _, _, modStatus = CalendarGetDayEvent(monthOffset, eventDay, i)      
      local et = {index = i, titolo = title, meseDiff = monthOffset, giorno = eventDay, ora = hour, min = minute, mod = modStatus}
      self:SetTempVal("pickedEvent", et)
      ERA.openingEvent = true
      local inv = ERA:CALENDAR_OPEN_EVENT()      
      if inv and inv > 0 then
         self:ScheduleTimer("MassInvite",5)
         if self:Getopzioni("monitor") then
            self:ShowMonitor()
         end
      end      
   end
end
