--[[


]]--
local addonName, vars = ...
local L = vars.L --- localizzazione
local ERA = _G[addonName]
local _
local pairsByKeys = ERA.pairsByKeys

local on = L["Autoinvito \|cFF00FF00ON\|r"]
local off =  L["Autoinvito \|cFFFF0000OFF\|r"]
local ON = L["\|cFF00FF00ON\|r"]
local OFF = L["\|cFFFF0000OFF\|r"]

local HideUIPanel, IsInGuild, pairs,next,format, UnitAffectingCombat = HideUIPanel, IsInGuild, pairs,next,string.format,UnitAffectingCombat

--<GET/SET Generici>
--get/set a seconda di #info (il nodo nell'interfaccia delle opzioni)
local GET = {
	[1] = function(info) return ERA.db.profile[info[#info]]end,
	[2] = function(info) return ERA.db.profile[info[#info-1]][info[#info]]end,
	[3] = function(info) return ERA.db.profile[info[#info-2]][info[#info-1]][info[#info]]end,
	[4] = function(info) return ERA.db.profile[info[#info-3]][info[#info-2]][info[#info-1]][info[#info]]end,
	[5] = function(info) return ERA.db.profile[info[#info-4]][info[#info-3]][info[#info-2]][info[#info-1]][info[#info]]end,
}

local SET = {
	[1] = function(info, val) ERA.db.profile[info[#info]] = val end,
	[2] = function(info, val) ERA.db.profile[info[#info-1]][info[#info]] = val end,
	[3] = function(info, val) ERA.db.profile[info[#info-2]][info[#info-1]][info[#info]] = val end,
	[4] = function(info, val) ERA.db.profile[info[#info-3]][info[#info-2]][info[#info-1]][info[#info]] = val end,
	[5] = function(info, val) ERA.db.profile[info[#info-4]][info[#info-3]][info[#info-2]][info[#info-1]][info[#info]] = val end,
}
--OPTIONS GET
function ERA:DBGet(info)
	return GET[#info](info)
end

--OPTIONS SET
function ERA:DBSet(info, val)
	SET[#info](info, val)
end

--funzioncina per creare un po' di spazio nelle opzioni
local function space(order, size)
	return {
		order = order,
		type = "description",
		name = "",
		width = size or "full",
	}
end

--ordina la lista dei pulsanti nelle opzioni
function ERA:SortView(tab)
	if not self.options then return end
	if not next(tab) then return end
	local i = 1
	for name in pairsByKeys(tab) do	
		tab[name].order = i
		i = i+1
	end
end
--

local function TargetOrFocusOptions(what)
	if what and (what =="focus" or what =="target") then
		local opt =	{
			type = "group",
			order = what == "focus" and 20 or 10,
			name =  format(L["%s Monitor"],ERA:Upper1(what)),
			desc = format(L["Opzioni per il monitor del %s"],ERA:Upper1(what)),						
			inline = true,
			args = {
				attiva = {
					type = "toggle",
					order = 10,
					name = format(L["Attiva il monitor per il %s"],ERA:Upper1(what)),	
					desc = format(L["Mostra il numero dei dps sul tuo %s, il totale dei dps vivi e una lista dei loro nomi."],what),	
					width = "full",
					set = function(info,val)
						ERA:DBSet(info,val)
						ERA:RegisterEvent("PLAYER_REGEN_DISABLED")
						end,
					},
				raidOnly = {
					type = "toggle",
					order = 20,
					name = L["Solo in raid"],	
					desc = L["Attiva il monitor solo in raid."],						
					}, 
					notInLFR = {
					type = "toggle",
					order = 30,
					name = L["Non nel Raid Finder"],	
					desc = L["Nascondi il monitor nei gruppi Ricerca delle Incursioni."],						
					}, 		
					inverti = {
						type = "toggle",
						order = 30,
						name = format(L["Segna chi \|cFFFF0000NON|r è sul %s"],	what),
						desc = format(L["Invece di mostrare chi è sul %s, mostra chi deve ancora targettarlo."],what),
						width = "full",
					}, 					
				test = {
					type = "toggle",
					order = 100,
					name = L["Test mode"],
					desc = L["test mode desc"],	
					width = "full",
					get = function(info) return ERA["_"..info[#info-1].."MonitorTest"] end,
					set = function(info, state)
						ERA["_"..what.."MonitorTest"] = state
						if state then 
							ERA:ShowAssistMonitor(info[#info-1],true)
						else
							if not UnitAffectingCombat("player") then 
								ERA:HideAssistMonitor(info[#info-1])
							end	
						end
					end,
					disabled = function (info) return not ERA:IsMonitorEnabled(info[#info-1]) end,
				},						
			},
		}
		return opt
	end
end

function ERA:ImportaEventoOpt(order)
local opt = {
			type = "group",
			order = order or 10,
			name = L["Importa Evento"],
			inline = true,
			args = {
				giorno = {
					type = "select",
					order = 10,
					name = L["Giorno"],
					style = "dropdown",
					values = function() 
							local g = {}
							for i = 1, 31 do
								g[i] = i
							end
						return g
					end,
					get = function(info) return ERA:GetTempVal("giorno") end,
					set = function(info, val) ERA:SetTempVal("giorno", val) end,
				},						
				mese = {
					type = "select",
					order = 20,
					name = L["Mese"],
					style = "dropdown",
					values = {FULLDATE_MONTH_JANUARY, FULLDATE_MONTH_FEBRUARY, FULLDATE_MONTH_MARCH, FULLDATE_MONTH_APRIL, FULLDATE_MONTH_MAY, FULLDATE_MONTH_JUNE, FULLDATE_MONTH_JULY, FULLDATE_MONTH_AUGUST, FULLDATE_MONTH_SEPTEMBER, FULLDATE_MONTH_OCTOBER, FULLDATE_MONTH_NOVEMBER, FULLDATE_MONTH_DECEMBER,},
					get = function(info) return ERA:GetTempVal("mese") end,
					set = function(info, val) ERA:SetTempVal("mese", val) end,
				},
				anno = {
					type = "select",
					order = 30,
					name = L["Anno"],
					style = "dropdown",
					values = {[2015]=2015,[2016]=2016,[2017]=2017,[2018]=2018,},
					get = function(info) return ERA:GetTempVal("anno") end,
					set = function(info, val) ERA:SetTempVal("anno", val) end,
				},
				_space = space(40),
				importa = {
					type = "execute",
					order = 50,
					width = "double",
					name = L["Importa dal calendario"],
					desc = L["Viene effettuata una importazione dei confermati dall'evento presente nel giorno selezionato."],
					disabled = function() return not ERA:GetTempVal("calendarOpened") end,
					func = function()								
						local annoC,meseC = ERA:GetGameTime("a","M")
						local year = (ERA:GetTempVal("anno") - annoC)*12
						local monthOffset = ERA:GetTempVal("mese") - meseC + year										
						ERA:GetDayEvents(nil, ERA:GetTempVal("giorno"), monthOffset)								
						--print(ERA:GetTempVal("giorno"), ERA:GetTempVal("mese"), ERA:GetTempVal("anno"), monthOffset)
					end,
				},
			},
		}
	return opt
end

function ERA:CalendarIntegrationOptions(order)
	local a,m,g = ERA:GetGameTime("a","M","g")
	ERA:SetTempVal("anno", a)
	ERA:SetTempVal("mese", m)
	ERA:SetTempVal("giorno", g)

	local opt = {
				type = "group",
				order = order,
				name = L["Calendario"],
				desc = L["Opzioni per l'importazione degli eventi dal calendario."],
				args = {				
					serverTime = {
						type = "toggle",
						order = 10,
						name = L["Usa l'ora del server"],
						desc = L["Usa il tempo del server invece di quello locale per gli orari degli eventi."],							
					},
					serverFusoOrario = {
						type = "range",
						order = 20,
						width = "double",
						name = L["Fuso orario rispetto al server"],
						desc = L["La differenza presente tra il tempo locale e quella del server."],						
						softMin = -10,
						softMax= 10,
						min = -23,
						max = 23,
						step = 0.5,
					},					
					integraInvita = {
						type = "toggle",
						order = 30,
						name = format(L['Importa da "%s"'],CALENDAR_INVITE_MEMBERS),
						desc = format(L['Quando premi "%s" nell\'evento in calendario vengono importati i confermati.'],CALENDAR_INVITE_MEMBERS),
						width = "full",
					},
					importaEvento = ERA:ImportaEventoOpt(50),
				},
			}
	return opt

end

function ERA:AddBlizOpt()
	local options = { 
		name = "Figolas Options",
		type = "group",
		handler = ERA,				
		childGroups ="tab",
		args = {
			open = {
				order = 5,
				type = "execute",
				name = L["Apri Pannello delle opzioni"],				
				width = "double",
				func = function() 
						InterfaceOptionsFrame:Hide()                 
						HideUIPanel(GameMenuFrame)
						--LibStub("AceConfigDialog-3.0"):Open(addonName)
						ERA:OpenOptions()
					end
				},		
			hint = {
				order = 10,
				type = "description",
				name = L["Puoi usare anche il comando \|cFFFF0000/fig|r."],
				width = "full",
				fontSize = "large",
			},
		},		
	}
	LibStub("AceConfig-3.0"):RegisterOptionsTable("BlizOpt", options)	
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("BlizOpt", "Figolas")	
end

function ERA:OpenOptions(tab)
	if not self.options then ERA:IniOptions() end
	LibStub("AceConfigDialog-3.0"):Open(addonName)	
	if tab then
		LibStub("AceConfigDialog-3.0"):SelectGroup(addonName, tab)
	end
end

function ERA:IniOptions()
	
	local options = { 
		name = "Figolas Options",
		type = "group",
		handler = ERA,		
		get= "DBGet",
		set= "DBSet",	
		childGroups ="tab",
		args = {
			raid ={
				order = 20,
				type ="group",
				name = L["Draft e Roster"],
				desc = L["Lista di raiders e composizione del raid"],			
				args = {
					invita = {
						order = 5,
						type = "execute",
						name = L["Invita"],
						desc = L['"/fig i" - Invita tutti quelli nella lista dei confermati'],
						func = "MassInvite",
					},
					importa = ERA:ImportaEventoOpt(7),
					drafted = {
						order = 10,
						type = "group",
						name = L["Drafted"],
						inline = true,
						args = {
							
						},
					},
					_wipe = {
						order = 20,
						type = "execute",
						name = L["Cancella tutti i confermati"],
						desc = L["Elimina tutta lista dei confermati"],
						func = "WipeDrafted",
						width = "double",						
					},
					list = {
						order = 30,
						type = "input",
						width = "full",
						name = L["Lista dei confermati"],
						desc = L["Aggiungi i membri della lista ai confermati"],
						multiline = 4,						
						set = "ListToDrafted",
					},
					_add={
						type ="input",
						order = 40,
						name=L["Aggiungi un membro al roster"],
						width = "double",
						validate = "Validate",
						get = false,
						set = "AddToRoster",
					},
					_space = space(15, "half"),
					_rim = {
						order = 50	,
						type = "toggle",
						name = L["Rimuovi da roster"],
						desc = L["Seleziona per rimuovere i membri del roster"],	
						width = "full",						
						get = function ()
							return self.ar
						end,
						set = function(info,state,...)
							self.ar = state
							return state
						end,
					},					
					roster = {
						order = 70,
						type = "group",
						name = "Roster",
						desc=L["La lista di tutti i potenziali raidanti in gilda da cui scegliere"],
						inline = true,
						args = {
						},
					},
				},												
			},
			whisper = {
					order = 30,
					type ="group",
					name = L["AutoInvito/Whisper"],
					desc = L["Setta la parola chiave e altre opzioni."],
					args = {
						_startwhisper = {
						order = 5,
						type = "execute",
						name = function()
							local n = ERA:Get("whisper","on") and L["Blocca"] or L["Inizia"]
							return(n..L[" gli inviti"])						
						end,
						desc = L["/fig w - Fai partire/blocca la possibilità di autoinvitarsi."],						
						func = "SwitchWhisper",
						},
						alwaysOn = {
							order = 7,
							type = "toggle",
							name = L["Autoinvito sempre attivo"],
							width = "double",
							desc = L["Non è necessario avviare o fermare manualmente l'invito con i whisper. C'è a chi non da noia..."],							
							set = function(info, state) 							
								ERA:Getwhisper()["alwaysOn"] = state														
								ERA:SwitchWhisper(true)
							end,
						},
						_desc = {
							order = 8,
							type = "description",
							name = function()
								return(ERA:Get("whisper","on") and on or off)
							end,
						},
						safe = {
							order = 10,
							type = "toggle",
							name =L["Invito Sicuro"],
							desc=L["Se attivo non invita durante un boss fight."],
						},						
						_space1 = space(11),
						kwordList = {
							order = 20,
							type = "input",
							name = L["Parole Chiave"],
							width = "full",
							desc = L["Lista di parole per essere invitati in gruppo."],		
							set = function(info, val)
								ERA:DBSet(info, val)
								ERA:KwordListToTable()
							end,							
						},
						casesensitive = {
							order = 25,
							type = "toggle",
							width = "full",
							name =L["Distingui maiuscole/minuscole"],
							desc=L["Se attivo cerca un'esatta corrispondenza con le parole (es: Raid è diverso da raid)"],
							set = function(info, val)
								ERA:DBSet(info, val)
								ERA:KwordListToTable()
							end,
						},						
						_space2 = space(28, "full"),
						annuncia = {
							order = 30,
							type = "toggle",
							width = "full",
							name =L["Annuncia quando partono gli inviti"],
							desc=L["Se attivo usa il messaggio sotto per annunciare l'apertura degli inviti."],
						},
						startMsg = {
							order = 40,
							type = "input",
							width = "full",
							name = L["Messaggio iniziale"],
							desc = L["Messaggio con il quale si annuncia l'apertura degli inviti."],
						},						
						_lim = {
							order = 60,
							type = "header",
							name =L["Limitazioni"],
							width = "full",
						},
						guildOnly = {
							order = 70,
							type = "toggle",
							name = L["Accetta solo membri della gilda."],
							desc = L["Autoinvita solo i membri della gilda."],
							width = "full",
						},
						maxLvlOnly = {
							order = 80,
							type = "toggle",
							name = function() return(L["Solo lvl "]..ERA.maxLvl)end,
							desc = L["Invita solo se chi sussurra è di massimo livello."],							
							disabled = function() return not ERA:Getwhisper()["guildOnly"] end,
						},
						minRank = {
							order = 90,
							type = "toggle",
							name = L["Richiede Grado minimo"],
							desc = L["Invita solo se chi sussurra ha un grado minimo in gilda."],
							disabled = function() return not ERA:Getwhisper()["guildOnly"] end,														
						},
						minRankLvl = {
							order = 100,
							type = "select",
							name = L["Grado minimo richiesto"],
							desc = L["Imposta il grado minimo richiesto."],
							values = ERA.ranks,
							style="dropdown",
							disabled = function() return not (ERA:Getwhisper()["minRank"] and ERA:Getwhisper()["guildOnly"]) end,							
							set = function(i, val) ERA:Getwhisper()["minRankLvl"] = val 
							ERA:Getwhisper()["minRankname"] = self.ranks[val] end,
						},						
						_space4 = space(140,"full"),
						_add={
							type ="input",
							order = 150,
							name=L["Aggiungi alla blacklist"],
							desc = L["Le persone nella lista non verranno invitate nonostante i whisper."],
							get = false,
							set = "AddToBlacklist",
							validate = "Validate",
							width = "double",
						},						
						_addTarget = {
							order = 160,
							type= "execute",
							name = L["Aggiungi bersaglio alla Blacklist"],
							desc = L["Il bersaglio verrà aggiunto alla blacklist."],
							func = function(info) 
								local name = GetUnitName("target", true)
								if name then
									ERA:AddToBlacklist(info,name)	
								end
							end,
						},
						blacklist = {
							order = 170,
							type = "group",
							name = L["Blacklist"],
							inline = true,
						args = {
							
						},
					},
						
				},
			},				
			promozione = {
				order = 50,
				type ="group",
					name = L["Promuovi/Degrada"],
					desc = L["Promuovi o degrada i membri ad un rank scelto."],
					args = {
						MLootTit = {
							order = 10,
							type = "header",
							name = L["Regole per il bottino"],
							width ="full",
						},
						forzaLM = {
							order = 15,
							type = "toggle",
							name = L["Forza il Loot Method"],		
							width = "full",							
							desc =L["Se attivo, setta automaticamente il Loot Method (Regola di Predazione -_-)."],
						},
						lootMethod = {
							order = 20,
							type = "select",
							name = L["Loot Method"],
							desc= L["Setta il tipo di regola per il bottino. Se su Master Looter cerca il responsabile nella lista."],
							values = {["freeforall"] = "Free for All",["roundrobin"] = "Rotazione Fissa",["group"] = "Group Loot",["needbeforegreed"] = "Need before Greed",["master"] = "Master Looter",["personalloot"]="Personale",},
							style="dropdown",							
						},
						MLooters = {
							order = 30,
							type ="input",
							width = "full",
							name = L["Lista di nomi separati da virgole e/o spazi"],
							desc=L["Il primo tra questi presente in gruppo sarà il Responsabile del Bottino. Se la lista è vuota o nessuno è presente si usano le impostazioni manuali."]						
						},
						AssistTit = {
							order = 50,
							type = "header",
							name = L["Lista Assistenti"],
							width ="full",
						},
						assist = {
							order = 60,
							type ="input",
							width = "full",
							name = L["Lista di nomi separati da virgole e/o spazi"],
							desc=L["Tutti quelli qui indicati saranno assistenti."],											
						},
						tankAssist = {
							order = 70,
							type = "toggle",
							name = L["Setta i tank come assistenti"],
							width = "full",
							desc =L["Se attivo promuove i tank ad assistenti."],							
							set = function(info, state) ERA:Setpromozione("tankAssist", state)
									if not state then 
										ERA:UnregisterEvent("READY_CHECK")	
										ERA:UnregisterEvent("ROLE_CHANGED_INFORM")									
									else
										ERA:RegisterEvent("READY_CHECK")	
										ERA:RegisterEvent("ROLE_CHANGED_INFORM")									
									end
							end,						
						},
						ProDe = {
							order = 90,
							type = "header",
							name = L["Promuovi o Degrada i membri della Gilda"],
							width ="full",
						},				
						promuovi = {
							order = 110,
							type = "execute",
							name =L["Promuovi"],							
							desc=L["Promuovi i membri ad un rank scelto."],
							func = "PromuoviGilda",
							disabled = function() return not (IsInGuild() and ERA:CanPromote()) end,
						},
						up = {
							order = 120,
							type = "select",
							name = L["Gradi"],
							values = ERA.ranks,
							style="dropdown",							
							set = function(info, val) ERA:Setpromozione("up", val) 
								ERA:Setpromozione("upName", self.ranks[val])
							end,
							disabled = function() return not IsInGuild() end,
						},
						_space1 = space(130),
						degrada = {
							order = 140,
							type = "execute",
							name =L["Degrada"],
							desc=L["Degrada i membri ad un rank scelto."],
							func = "DegradaGilda",
							disabled = function() return not (IsInGuild() and ERA:CanDemote()) end,
						},
						down = {
							order = 150,
							type = "select",
							name = L["Gradi"],
							values = ERA.ranks,
							style="dropdown",
							set = function(info, val) ERA:Setpromozione("down", val) 
								ERA:Setpromozione("downName", self.ranks[val])
							end,
							disabled = function() return not IsInGuild() end,
						},
						nonUltra  = {
							order = 160,
							type = "toggle",
							name = function () return format("%s \|cFFFF0000%s\|r", L["Promuovi solo membri con un grado almeno"], ERA:Getpromozione("down") and self.ranks[ERA:Getpromozione("down")] or "...")
							end,
							width = "full",							
							desc = function() return format(L["Se attivo, i membri della gilda con un grado meno importante di %s non saranno promossi."], ERA:Getpromozione("down") and self.ranks[ERA:Getpromozione("down")] or "...")
							end,
						},
						
					},
			},
			opzioni = {
				order = 60,
				type ="group",
				name = L["Interfaccia e Varie"],
				args = {
					monitor = {
						order = 10,
						type = "toggle",
						name =L["Mostra il Monitor"],
						width="full",
						desc=L["Apri automaticamente il monitor quando partono gli inviti."],
					},						
					SetMT = {
						order = 20,
						type = "toggle",
						name =L["Setta Automaticamente i Main Tank"],
						width="full",
						desc=L["Controlla ad ogni Raid Check se i Main Tank sono assegnati correttamente, ed in caso contrario mostra un pulsante per settarli."],
					},					
					EPGP = {
						order = 30,
						type = "toggle",
						name = L["Usa EPGP"],
						desc = L["Abilita i pulsanti nel Monitor per velocizzare l'assegnazione dei punti. Numero e tipo di pulsanti possono essere personalizzati con i comandi successivi."],
						disabled = function() return not ERA.EPGP end,
						hidden = function() return not ERA.EPGP end,						
						set = function(info,val) 
							ERA:Setopzioni("EPGP",val)
							--Aggiorna il monitor in modo da cambiare subito l'UI
							ERA:CreateMonitorUI()
							ERA:AggiornaMonitor()
						end
					},	
					EPGPUIMngBtns = {
						order = 40,
						type = "group",
						name = L["Quantità Pulsanti EPGP"],
						desc =L["Permette di personalizzare il numero dei pulsanti EPGP nel Monitor."],
						inline = true,
						hidden = function() return  not ERA.EPGP or not ERA:Get("opzioni", "EPGP")end,
						args = {
							_addrem = {
								type = "select",
								order = 10,
								values = {["a"] = L["Aggiungi"],["r"] = L["Rimuovi"]},
								get = function() return ERA._addrem end;
								set = function(info, val) 
									for k,v in pairs(ERA._pulsanti) do
										ERA._pulsanti[k] = true
									end
									ERA._addrem = val 
									end;
								name = L["Azione"],
								desc = L["Permette di aggiungere o rimuovere un pulsante EPGP nel Monitor. Per rimuovere togli anche la spunta più sotto da quelli presenti che vuoi rimuovere. Per confermare l'azione premi Conferma."],
							},
							confirm = {
									type = "execute",
									order = 20,
									name = L["Conferma"],
									desc = L["Conferma le azioni selezionate."],
									func = function()																				
										if ERA._addrem == "a" then
											local n = ERA:AddNewEPGPBtn()											
											ERA._pulsanti["btn"..n] = true
										end
										if ERA._addrem == "r" then
											local wp, wdb = ERA._pulsanti, ERA:GetEPGPUICfg()
											ERA._pulsanti = {}
											ERA:NewEPGPUICfg()
											local i = 0
											local b = ""
											ERA:DelAllEPGPBtnsCmd()
											for k, v in pairsByKeys(wdb) do
												ERA.EPGPBtns[k] = nil --per quale mistico motivo devo azzerarli uno per uno?												
												if wp[k] then												
													i = i+1													
													b = "btn"..i
													ERA._pulsanti[b] =  true
													ERA:SetEPGPUICfg(b,v)
													ERA:NewEPGPBtnOpt(i)
													ERA:AddEPGPBtnToSlashCmd(b)
												end
											end											
										end		
										--ERA:HelpOptions()
										--Aggiorna il monitor se viene mostrato, in modo da presentare i cambiamenti subito
										ERA:CreateMonitorUI()
										ERA:AggiornaMonitor()
									end,
							},
							pulsanti = {
								type ="multiselect",
								style = "radio",
								name = L["Pulsanti"],
								desc = L["Togli la spunta dai pulsanti per rimuoverli, poi premi Conferma."],
								width = "half",
								values = function() 								
									if not next(ERA:GetEPGPUICfg()) then return {"nil"}end
									local l = {}
									local i = 0
									for k in pairsByKeys(ERA:GetEPGPUICfg()) do
										i = i+1
										l[k] = i										
									end									
									return l 
								end,
								disabled = function() return ERA._addrem ~= "r" end,
								hidden = function() return not next(ERA:GetEPGPUICfg())end,
								get = function(info,btn) return ERA._pulsanti[btn] end,
								set = function(info,btn,val) ERA._pulsanti[btn] = val end,
							},
						},					
					},
					EPGPUICfg = {
						order = 50,
						type = "group",
						name = L["Configurazione Pulsanti EPGP"],
						desc =L["Permette di personalizzare le funzioni dei singoli pulsanti EPGP nel Monitor."],
						inline = true,
						hidden = function() return  not ERA.EPGP or not ERA:Get("opzioni", "EPGP")or not next(ERA:GetEPGPUICfg()) end,
						args = {
						},
					},										
					desc = {
							order = 1000,
							type = "group",
							name = L["Comandi"],
							inline = true,
						args = {
							des = {
								order = 100,
								type= "description",		
								fontSize = "medium",
								name = function () 
								local msg = ""
									for k, v in pairsByKeys(ERA.Com) do		
										msg = format("%s\|cFFFFFF00/fig %-10s|r ---> \|cFF69CCF0%s\|r\n",msg, k, type(v.desc) == "function" and v.desc() or v.desc)
									end									
									return msg
								end	,
							},
						},
					},
				},
			},
			assistMonitor = {
				type = "group",
				order = 70,
				name = L["Assist Monitor"],
				desc = L["Mostra chi sta attaccando il tuo target o il tuo focus"],
				args = {				
					target = TargetOrFocusOptions("target"),											
					focus = TargetOrFocusOptions("focus"),
				},
			},
			calendar = ERA:CalendarIntegrationOptions(80),
			profiles = LibStub("AceDBOptions-3.0"):GetOptionsTable(ERA.db),
		},
	}
	self.options = options
	self.roster = options.args.raid.args.roster.args
	self.drafted = options.args.raid.args.drafted.args
	self.blacklist = options.args.whisper.args.blacklist.args
	self.EPGPBtns = options.args.opzioni.args.EPGPUICfg.args
	self.helpDesc = options.args.opzioni.args.desc.args
	LibStub("AceConfig-3.0"):RegisterOptionsTable(addonName, options)	
	
	--allinea UI e db
	if next(ERA:Getroster()) then
		for name in pairs(ERA:Getroster()) do
			ERA:AddToRoster(_,name)
		end	
		ERA:SortView(ERA.roster)
	end	
	if next(ERA:Getdrafted()) then
		for name in pairs(ERA:Getdrafted()) do
			ERA:AddToDraftedOpt(name)
		end	
		ERA:SortView(ERA.drafted)
	end	
	if next(ERA:Getblacklist()) then
		for name in pairs(ERA:Getblacklist()) do
			ERA:AddToBlacklist(nil,name)
		end	
		ERA:SortView(ERA.blacklist)
	end
	ERA._pulsanti = {}
	if next(ERA:GetEPGPUICfg()) then
		local i = 0		
		for k in pairsByKeys(ERA:GetEPGPUICfg()) do					
			i = i+1
			ERA:NewEPGPBtnOpt(i)
			ERA._pulsanti[k] = true
		end
	end	
end